6 GPG_CMD
="gpg --ignore-time-conflict --no-options --no-default-keyring"
8 # gpg needs a trustdb to function, but it can't be invalid (not even empty)
9 # so we create a temporary directory to store our fresh readable trustdb in
10 TRUSTDBDIR
="$(mktemp -d)"
11 CURRENTTRAP
="${CURRENTTRAP} rm -rf '${TRUSTDBDIR}';"
12 trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
13 chmod 700 "$TRUSTDBDIR"
14 # We also don't use a secret keyring, of course, but gpg panics and
15 # implodes if there isn't one available - and writeable for imports
16 SECRETKEYRING
="${TRUSTDBDIR}/secring.gpg"
18 GPG_CMD
="$GPG_CMD --secret-keyring $SECRETKEYRING"
19 GPG_CMD
="$GPG_CMD --trustdb-name ${TRUSTDBDIR}/trustdb.gpg"
21 # now create the trustdb with an (empty) dummy keyring
22 $GPG_CMD --quiet --check-trustdb --keyring $SECRETKEYRING
23 # and make sure that gpg isn't trying to update the file
24 GPG_CMD
="$GPG_CMD --no-auto-check-trustdb --trust-model always"
28 MASTER_KEYRING
='&keyring-master-filename;'
29 eval $(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)
30 ARCHIVE_KEYRING
='&keyring-filename;'
31 eval $(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)
32 REMOVED_KEYS
='&keyring-removed-filename;'
33 eval $(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)
34 ARCHIVE_KEYRING_URI
='&keyring-uri;'
35 eval $(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)
36 TMP_KEYRING
=/var
/lib
/apt
/keyrings
/maybe
-import-keyring.gpg
39 if [ "$(id -u)" -ne 0 ]; then
40 echo >&1 "ERROR: This command can only be used by root."
45 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
48 if ! [ -e "$path" ]; then
55 add_keys_with_verify_against_master_keyring
() {
59 if [ ! -f "$ADD_KEYRING" ]; then
60 echo "ERROR: '$ADD_KEYRING' not found"
63 if [ ! -f "$MASTER" ]; then
64 echo "ERROR: '$MASTER' not found"
68 # when adding new keys, make sure that the archive-master-keyring
70 # all keys that are exported must have a valid signature
71 # from a key in the $distro-master-keyring
72 add_keys
=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
73 all_add_keys
=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5`
74 master_keys
=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
76 # ensure there are no colisions LP: #857472
77 for all_add_key
in $all_add_keys; do
78 for master_key
in $master_keys; do
79 if [ "$all_add_key" = "$master_key" ]; then
80 echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted"
86 for add_key
in $add_keys; do
87 # export the add keyring one-by-one
89 $GPG_CMD --keyring $ADD_KEYRING --output $TMP_KEYRING --export $add_key
90 # check if signed with the master key and only add in this case
92 for master_key
in $master_keys; do
93 if $GPG_CMD --keyring $MASTER --keyring $TMP_KEYRING --check-sigs --with-colons $add_key | grep '^sig:!:' | cut
-d: -f5 | grep -q $master_key; then
94 $GPG --import $TMP_KEYRING
98 if [ $ADDED = 0 ]; then
99 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
105 # update the current archive signing keyring from a network URI
106 # the archive-keyring keys needs to be signed with the master key
107 # (otherwise it does not make sense from a security POV)
109 # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128))
112 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
113 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
117 # in theory we would need to depend on wget for this, but this feature
118 # isn't useable in debian anyway as we have no keyring uri nor a master key
119 if ! which wget
>/dev
/null
2>&1; then
120 echo >&2 "ERROR: an installed wget is required for a network-based update"
123 if [ ! -d /var
/lib
/apt
/keyrings
]; then
124 mkdir -p /var
/lib
/apt
/keyrings
126 keyring
=/var
/lib
/apt
/keyrings
/$(basename $ARCHIVE_KEYRING)
128 if [ -e $keyring ]; then
129 old_mtime
=$(stat -c %Y $keyring)
131 (cd /var
/lib
/apt
/keyrings
; wget
--timeout=90 -q -N $ARCHIVE_KEYRING_URI)
132 if [ ! -e $keyring ]; then
135 new_mtime
=$(stat -c %Y $keyring)
136 if [ $new_mtime -ne $old_mtime ]; then
137 echo "Checking for new archive signing keys now"
138 add_keys_with_verify_against_master_keyring
$keyring $MASTER_KEYRING
143 if [ ! -f $ARCHIVE_KEYRING ]; then
144 echo >&2 "ERROR: Can't find the archive-keyring"
145 echo >&2 "Is the &keyring-package; package installed?"
150 # add new keys from the package;
152 # we do not use add_keys_with_verify_against_master_keyring here,
153 # because "update" is run on regular package updates. A
154 # attacker might as well replace the master-archive-keyring file
155 # in the package and add his own keys. so this check wouldn't
156 # add any security. we *need* this check on net-update though
157 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
159 if [ -r "$REMOVED_KEYS" ]; then
160 # remove no-longer supported/used keys
161 keys
=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
163 if $GPG --list-keys --with-colons | grep ^pub
| cut
-d: -f5 | grep -q $key; then
164 $GPG --quiet --batch --delete-key --yes ${key}
168 echo "Warning: removed keys keyring $REMOVED_KEYS missing or not readable" >&2
172 remove_key_from_keyring
() {
173 local GPG
="$GPG_CMD --keyring $1"
174 # check if the key is in this keyring: the key id is in the 5 column at the end
175 if ! $GPG --with-colons --list-keys 2>&1 | grep -q "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+$2:"; then
178 if [ ! -w "$1" ]; then
179 echo >&2 "Key ${2} is in keyring ${1}, but can't be removed as it is read only."
182 # check if it is the only key in the keyring and if so remove the keyring alltogether
183 if [ '1' = "$($GPG --with-colons --list-keys | grep "^pub:[^:]*:[^:]*:[^:]*:[0-9A-F]\+:" | wc -l)" ]; then
184 mv -f "$1" "${1}~" # behave like gpg
187 # we can't just modify pointed to files as these might be in /usr or something
190 REALTARGET
="$(readlink -f "$1")"
191 mv -f "$1" "${1}.dpkg-tmp"
192 cp -a "$REALTARGET" "$1"
195 # delete the key from the keyring
196 $GPG --batch --delete-key --yes "$2"
197 if [ -n "$REALTARGET" ]; then
198 # the real backup is the old link, not the copy we made
199 mv -f "${1}.dpkg-tmp" "${1}~"
206 # if a --keyring was given, just remove from there
207 if [ -n "$FORCED_KEYRING" ]; then
208 remove_key_from_keyring
"$FORCED_KEYRING" "$1"
210 # otherwise all known keyrings are up for inspection
211 local TRUSTEDFILE
="/etc/apt/trusted.gpg"
212 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
213 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
214 remove_key_from_keyring
"$TRUSTEDFILE" "$1"
215 TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
216 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
217 if [ -d "$TRUSTEDPARTS" ]; then
218 for trusted
in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
219 remove_key_from_keyring
"$trusted" "$1"
228 echo "Usage: apt-key [--keyring file] [command] [arguments]"
230 echo "Manage apt's list of trusted keys"
232 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
233 echo " apt-key del <keyid> - remove the key <keyid>"
234 echo " apt-key export <keyid> - output the key <keyid>"
235 echo " apt-key exportall - output all trusted keys"
236 echo " apt-key update - update keys using the keyring package"
237 echo " apt-key net-update - update keys using the network"
238 echo " apt-key list - list keys"
239 echo " apt-key finger - list fingerprints"
240 echo " apt-key adv - pass advanced options to gpg (download key)"
242 echo "If no specific keyring file is given the command applies to all keyring files."
245 while [ -n "$1" ]; do
251 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ] || [ "$2" = 'adv' ]; then
252 GPG
="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
254 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
260 requires_root
() { true
; }
264 echo >&2 "Unknown option: $1"
272 if [ -z "$TRUSTEDFILE" ]; then
273 TRUSTEDFILE
="/etc/apt/trusted.gpg"
274 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
275 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
276 if [ -r "$TRUSTEDFILE" ]; then
277 GPG
="$GPG --keyring $TRUSTEDFILE"
279 GPG
="$GPG --primary-keyring $TRUSTEDFILE"
280 TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
281 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
282 if [ -d "$TRUSTEDPARTS" ]; then
283 # strip / suffix as gpg will double-slash in that case (#665411)
284 STRIPPED_TRUSTEDPARTS
="${TRUSTEDPARTS%/}"
285 if [ "${STRIPPED_TRUSTEDPARTS}/" = "$TRUSTEDPARTS" ]; then
286 TRUSTEDPARTS
="$STRIPPED_TRUSTEDPARTS"
288 for trusted
in $(run-parts --list "$TRUSTEDPARTS" --regex '^.*\.gpg$'); do
289 GPG
="$GPG --keyring $trusted"
295 if [ -z "$command" ]; then
301 if [ "$command" != "help" ] && ! which gpg
>/dev
/null
2>&1; then
302 echo >&2 "Warning: gnupg does not seem to be installed."
303 echo >&2 "Warning: apt-key requires gnupg for most operations."
310 init_keyring
"$TRUSTEDFILE"
311 $GPG --quiet --batch --import "$1"
315 init_keyring
"$TRUSTEDFILE"
319 init_keyring
"$TRUSTEDFILE"
323 init_keyring
"$TRUSTEDFILE"
327 init_keyring
"$TRUSTEDFILE"
328 $GPG --batch --list-keys
331 init_keyring
"$TRUSTEDFILE"
332 $GPG --batch --fingerprint
335 init_keyring
"$TRUSTEDFILE"
336 $GPG --armor --export "$1"
339 init_keyring
"$TRUSTEDFILE"
340 $GPG --armor --export
343 init_keyring
"$TRUSTEDFILE"
344 echo "Executing: $GPG $*"